#include	<afx.h>
#include	<stdlib.h>

inline	CString	GetTempPath	(void)
{
	CString	tmpName ;
	UINT	size = MAX_PATH ;
	::GetTempPath	(size,tmpName.GetBuffer(size)) ;
	tmpName.ReleaseBuffer() ;
	return	tmpName ;
	}

inline
CString	GetFileDir (
	const CString& pathName						//	tpX
	)
{
	CString	fileDrv ;
	CString	fileDir ;
	_tsplitpath(pathName,fileDrv.GetBuffer(1024),fileDir.GetBuffer(1024),NULL,NULL) ;
	fileDrv.ReleaseBuffer() ;
	fileDir.ReleaseBuffer() ;
	return	fileDrv+fileDir ;
	}

inline
CString	GetFileName (
	const CString& pathName						//	tpX
	)
{
	CString	fileTtl ;
	CString	fileExt ;
	_tsplitpath(pathName,NULL,NULL,fileTtl.GetBuffer(1024),fileExt.GetBuffer(1024)) ;
	fileTtl.ReleaseBuffer() ;
	fileExt.ReleaseBuffer() ;
	return	fileTtl+fileExt ;
	}

inline
CString	GetFileExt (
	const CString& pathName						//	tpX
	)
{
	CString	fileExt ;
	_tsplitpath(pathName,NULL,NULL,NULL,	fileExt.GetBuffer(1024)) ;
	fileExt.ReleaseBuffer() ;
	if (fileExt.GetLength()>0) {
		fileExt = fileExt.Mid(1) ;
		}
	return	fileExt ;
	}

////
//*******************************************************************************
//	֐	FLbVt@C̕␳
//	쐬	FfOW^OV^PO
//	ύX	FfOW^PO^OV	GetLength  GetLengthB() ɕύX
//*******************************************************************************
inline	CString		CacheFile_CutPathName (LPCTSTR srcName)
{
	#define	C_File_PathMax	100
	CString	cutName = srcName ;
	if ((cutName.GetLength() > C_File_PathMax)/*	||
		(GetLengthB(cutName) > C_File_PathMax)*/) {
		CString	srcFold = ::GetFileDir	(srcName) ;
		CString	srcPage = ::GetFileDir	(srcFold) ;
		CString	docPage = ::GetFileName	(srcPage) ;
		CString	docFold = ::GetFileName	(srcFold) ;
		CString	docName = ::GetFileName	(srcName) ;
		CString	docPath ;
	//	if (GetLengthB(docPage) > 30)	{	docPage = ::CutString(docPage,30) ;	}
		if (docPage.GetLength() > 30)	{	docPage = docPage.Left(30) ;		}
		{
			if		(docPage.GetLength() +	docFold.GetLength() + docName.GetLength() < C_File_PathMax) {
				docPath = docPage + _T("\\") +	docFold + _T("\\") +	docName ;
				}
			else if	(						docFold.GetLength() + docName.GetLength() < C_File_PathMax) {
				docPath = 						docFold + _T("\\") +	docName ;
				}
			else {
				docPath = 												docName ;
				}
			}
		cutName = docPath ;
		}
	#ifdef	_DEBUG___
		afxDump << CString(srcName).GetLength() << "\t"// << GetLengthB(srcName) << "\t"
				<< cutName << "\t" << srcName << "\r\n" ;
	#endif
	return	cutName ;
	}

////
//*******************************************************************************
//	֐	F̃tH_̎擾
//		F߂l͒ʏ '\' ŏI`ŕԂ
//	쐬	FfOR^OS^PU
//*******************************************************************************
CString	CacheFile_GetFolder	(
	const CString&	base
,	const CString&	sub1	//	=	_T("")
,	const CString&	sub2	//	=	_T("")
,	const CString&	sub3	//	=	_T("")
,	const CString&	sub4		=	_T("")
	)
{
	CString	folder ;
	{	//	ꎞt@Cp̃fBNg̃pX̎擾
		folder = ::GetTempPath() ;
		}
	CString	folderFull = folder ;
	{
		if (!base.IsEmpty()) {	folderFull +=			 base ;	}
		if (!sub1.IsEmpty()) {	folderFull += _T("\\")	+sub1 ;	}
		if (!sub2.IsEmpty()) {	folderFull += _T("\\")	+sub2 ;	}
		if (!sub3.IsEmpty()) {	folderFull += _T("\\")	+sub3 ;	}
		if (!sub4.IsEmpty()) {	folderFull += _T("\\")	+sub4 ;	}
		}
	{	//	̕@łȂ ASP  COM T[oƂĎgpƂɐfłȂƂ
		CFileStatus	status ;
		if (CFile::GetStatus(folderFull,status)) {
			if (status.m_attribute & CFile::directory) {
				return	(folderFull+_T("\\")) ;
				}
			}
		}
	{	//	tH_݂ȂƂ́C
	//	if (!CreateFolder(folderFull))	{	return	folder+base ;	}
		}
	return	(folderFull+_T("\\")) ;
	}

////
//*******************************************************************************
//	֐	Ft@CŎgpłȂ̂̑̕ւ̕ύX
//	쐬	FfOQ^PO^QT
//	ύX	FfOV^PQ^OU	UNICODE Ή
//	ύX	FfPP^OT^PV	\r,\n ȂǂɑΉ
//*******************************************************************************
CString	ChangeFileSeparator	(const CString& name)
{
	CString	newName = name ;
	for (int index=0 ; index<newName.GetLength() ; index++) {
		if (_istlead(newName[index]))	{	//	Sp̓XLbv
			index++ ;
			continue ;
			}
		TCHAR	c = newName[index] ;
		switch	(c) {
			case	'\\' :		c = '_' ;		break ;
			case	'/' :		c = '_' ;		break ;
			case	':' :		c = '_' ;		break ;
			case	',' :		c = '.' ;		break ;
			case	';' :		c = '.' ;		break ;
			case	'*' :		c = 'x' ;		break ;
			case	'?' :		c = '_' ;		break ;
			case	'\"' :		c = '.' ;		break ;
			case	'<' :		c = '(' ;		break ;
			case	'>' :		c = ')' ;		break ;
			case	'|' :		c = '.' ;		break ;
			case	' ' :		c = '_' ;		break ;
			case	'\r' :		c = '.' ;		break ;
			case	'\n' :		c = '.' ;		break ;
			case	'\t' :		c = '.' ;		break ;
			default :			continue ;		break ;
			}
		newName.SetAt(index,c) ;
		}
	return	newName ;
	}

#define		CMF_Root	_T("Cache.tmp")
#define		CMF_Sub1	_T("CachMF")
#define		CMF_Sub2	_T("Other")

inline	CString	GetPathEMF	(LPCTSTR docPath)
{
	CString	ext = ::GetFileExt(docPath) ;
	CString	docName = CacheFile_CutPathName(docPath) ;
	CString	emfName	= CacheFile_GetFolder(CMF_Root,CMF_Sub1,CMF_Sub2,ext)
					+ ChangeFileSeparator	(docName)	+ _T(".emf") ;
	return	emfName ;
	}
